"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _FILTER_TITLES;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

Object.defineProperty(exports, "__esModule", { value: true });
var classnames = require("classnames");
var React = require("react");
var const_1 = require("../const");
var FILTER_TITLES = (_FILTER_TITLES = {}, _defineProperty(_FILTER_TITLES, const_1.SHOW_ALL, "All"), _defineProperty(_FILTER_TITLES, const_1.SHOW_ACTIVE, "Active"), _defineProperty(_FILTER_TITLES, const_1.SHOW_COMPLETED, "Completed"), _FILTER_TITLES);

var Footer = function (_React$PureComponent) {
    _inherits(Footer, _React$PureComponent);

    function Footer() {
        _classCallCheck(this, Footer);

        return _possibleConstructorReturn(this, (Footer.__proto__ || Object.getPrototypeOf(Footer)).apply(this, arguments));
    }

    _createClass(Footer, [{
        key: "renderTodoCount",
        value: function renderTodoCount() {
            var activeCount = this.props.activeCount;

            var itemWord = activeCount === 1 ? "item" : "items";
            return React.createElement("span", { className: "todo-count" }, React.createElement("strong", null, activeCount || "No"), " ", itemWord, " left");
        }
    }, {
        key: "renderFilterLink",
        value: function renderFilterLink(filter) {
            var title = FILTER_TITLES[filter];
            var _props = this.props,
                selectedFilter = _props.filter,
                onShow = _props.onShow;

            return React.createElement("a", { className: classnames({ selected: filter === selectedFilter }), style: { cursor: "pointer" }, onClick: function onClick() {
                    return onShow(filter);
                } }, title);
        }
    }, {
        key: "renderClearButton",
        value: function renderClearButton() {
            var _props2 = this.props,
                completedCount = _props2.completedCount,
                onClearCompleted = _props2.onClearCompleted;

            if (completedCount > 0) {
                return React.createElement("button", { className: "clear-completed", onClick: onClearCompleted }, "Clear completed");
            }
        }
    }, {
        key: "render",
        value: function render() {
            var _this2 = this;

            return React.createElement("footer", { className: "footer" }, this.renderTodoCount(), React.createElement("ul", { className: "filters" }, [const_1.SHOW_ALL, const_1.SHOW_ACTIVE, const_1.SHOW_COMPLETED].map(function (filter) {
                return React.createElement("li", { key: filter }, _this2.renderFilterLink(filter));
            })), this.renderClearButton());
        }
    }]);

    return Footer;
}(React.PureComponent);

exports.default = Footer;
//# sourceMappingURL=footer.js.map