"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _TODO_FILTERS;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var const_1 = require("../const");
var footer_1 = require("./footer");
var todo_item_1 = require("./todo-item");
var TODO_FILTERS = (_TODO_FILTERS = {}, _defineProperty(_TODO_FILTERS, const_1.SHOW_ALL, function () {
    return true;
}), _defineProperty(_TODO_FILTERS, const_1.SHOW_ACTIVE, function (todo) {
    return !todo.completed;
}), _defineProperty(_TODO_FILTERS, const_1.SHOW_COMPLETED, function (todo) {
    return todo.completed;
}), _TODO_FILTERS);

var MainSection = function (_React$PureComponent) {
    _inherits(MainSection, _React$PureComponent);

    function MainSection() {
        _classCallCheck(this, MainSection);

        var _this = _possibleConstructorReturn(this, (MainSection.__proto__ || Object.getPrototypeOf(MainSection)).apply(this, arguments));

        _this.state = { filter: const_1.SHOW_ALL };
        _this.handleClearCompleted = function () {
            _this.props.actions.clearCompleted();
        };
        _this.handleShow = function (filter) {
            _this.setState({ filter: filter });
        };
        return _this;
    }

    _createClass(MainSection, [{
        key: "renderToggleAll",
        value: function renderToggleAll(completedCount) {
            var _props = this.props,
                todos = _props.todos,
                actions = _props.actions;

            if (todos.length > 0) {
                return React.createElement("input", { className: "toggle-all", type: "checkbox", checked: completedCount === todos.length, onChange: actions.completeAll });
            }
        }
    }, {
        key: "renderFooter",
        value: function renderFooter(completedCount) {
            var todos = this.props.todos;
            var filter = this.state.filter;

            var activeCount = todos.length - completedCount;
            if (todos.length) {
                return React.createElement(footer_1.default, { completedCount: completedCount, activeCount: activeCount, filter: filter, onClearCompleted: this.handleClearCompleted.bind(this), onShow: this.handleShow.bind(this) });
            }
        }
    }, {
        key: "render",
        value: function render() {
            var _props2 = this.props,
                todos = _props2.todos,
                actions = _props2.actions;
            var filter = this.state.filter;

            var filteredTodos = todos.filter(TODO_FILTERS[filter]);
            var completedCount = todos.reduce(function (count, todo) {
                return todo.completed ? count + 1 : count;
            }, 0);
            return React.createElement("section", { className: "main" }, this.renderToggleAll(completedCount), React.createElement("ul", { className: "todo-list" }, filteredTodos.map(function (todo) {
                return React.createElement(todo_item_1.default, Object.assign({ key: todo.id, todo: todo }, actions));
            })), this.renderFooter(completedCount));
        }
    }]);

    return MainSection;
}(React.PureComponent);

exports.default = MainSection;
//# sourceMappingURL=main-section.js.map