"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var classnames = require("classnames");
var React = require("react");
var todo_text_input_1 = require("./todo-text-input");

var TodoItem = function (_React$PureComponent) {
    _inherits(TodoItem, _React$PureComponent);

    function TodoItem() {
        _classCallCheck(this, TodoItem);

        var _this = _possibleConstructorReturn(this, (TodoItem.__proto__ || Object.getPrototypeOf(TodoItem)).apply(this, arguments));

        _this.state = {
            editing: false
        };
        _this.handleDoubleClick = function () {
            _this.setState({ editing: true });
        };
        _this.handleSave = function (id, text) {
            if (text.length === 0) {
                _this.props.deleteTodo(id);
            } else {
                _this.props.editTodo(id, text);
            }
            _this.setState({ editing: false });
        };
        return _this;
    }

    _createClass(TodoItem, [{
        key: "render",
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                todo = _props.todo,
                completeTodo = _props.completeTodo,
                deleteTodo = _props.deleteTodo;

            var element = void 0;
            if (this.state.editing) {
                element = React.createElement(todo_text_input_1.default, { text: todo.text, editing: this.state.editing, onSave: function onSave(text) {
                        return _this2.handleSave(todo.id, text);
                    } });
            } else {
                element = React.createElement("div", { className: "view" }, React.createElement("input", { className: "toggle", type: "checkbox", checked: todo.completed, onChange: function onChange() {
                        return completeTodo(todo.id);
                    } }), React.createElement("label", { onDoubleClick: this.handleDoubleClick }, todo.text), React.createElement("button", { className: "destroy", onClick: function onClick() {
                        return deleteTodo(todo.id);
                    } }));
            }
            return React.createElement("li", { className: classnames({
                    completed: todo.completed,
                    editing: this.state.editing
                }) }, element);
        }
    }]);

    return TodoItem;
}(React.PureComponent);

exports.default = TodoItem;
//# sourceMappingURL=todo-item.js.map