"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

Object.defineProperty(exports, "__esModule", { value: true });
var classnames = require("classnames");
var React = require("react");

var TodoTextInput = function (_React$PureComponent) {
    _inherits(TodoTextInput, _React$PureComponent);

    function TodoTextInput() {
        _classCallCheck(this, TodoTextInput);

        var _this = _possibleConstructorReturn(this, (TodoTextInput.__proto__ || Object.getPrototypeOf(TodoTextInput)).apply(this, arguments));

        _this.state = {
            text: _this.props.text || ""
        };
        _this.handleSubmit = function (e) {
            var text = e.target.value.trim();
            if (e.which === 13) {
                _this.props.onSave(text);
                if (_this.props.newTodo) {
                    _this.setState({ text: "" });
                }
            }
        };
        _this.handleChange = function (e) {
            _this.setState({ text: e.target.value });
        };
        _this.handleBlur = function (e) {
            if (!_this.props.newTodo) {
                _this.props.onSave(e.target.value);
            }
        };
        return _this;
    }

    _createClass(TodoTextInput, [{
        key: "render",
        value: function render() {
            return React.createElement("input", { className: classnames({
                    "edit": this.props.editing,
                    "new-todo": this.props.newTodo
                }), type: "text", placeholder: this.props.placeholder, autoFocus: true, value: this.state.text, onBlur: this.handleBlur, onChange: this.handleChange, onKeyDown: this.handleSubmit });
        }
    }]);

    return TodoTextInput;
}(React.PureComponent);

exports.default = TodoTextInput;
//# sourceMappingURL=todo-text-input.js.map