"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var __decorate = undefined && undefined.__decorate || function (decorators, target, key, desc) {
    var c = arguments.length,
        r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
        d;
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
        if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    }return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = undefined && undefined.__metadata || function (k, v) {
    if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : new P(function (resolve) {
                resolve(result.value);
            }).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
var dob_1 = require("dob");
var src_1 = require("../../src");

var TODO = function () {
    function TODO() {
        _classCallCheck(this, TODO);

        this.store = dob_1.observable({
            todos: [{
                text: "learn Redux",
                completed: false,
                id: 0
            }]
        });
    }

    _createClass(TODO, [{
        key: "addTodoTask",
        value: function addTodoTask(text) {
            var _this = this;

            return function (dispatch, getState) {
                return __awaiter(_this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                        while (1) {
                            switch (_context.prev = _context.next) {
                                case 0:
                                    _context.next = 2;
                                    return new Promise(function (resolve) {
                                        return setTimeout(resolve, 100);
                                    });

                                case 2:
                                    dispatch({
                                        type: "todo.addTodo",
                                        payload: [text]
                                    });

                                case 3:
                                case "end":
                                    return _context.stop();
                            }
                        }
                    }, _callee, this);
                }));
            };
        }
    }, {
        key: "addTodo",
        value: function addTodo(text) {
            var id = this.store.todos.reduce(function (maxId, todo) {
                return Math.max(todo.id, maxId);
            }, -1) + 1;
            this.store.todos.unshift({
                id: id,
                text: text,
                completed: false
            });
        }
    }, {
        key: "deleteTodo",
        value: function deleteTodo(id) {
            var findIndex = this.store.todos.findIndex(function (todo) {
                return todo.id === id;
            });
            if (findIndex !== -1) {
                this.store.todos.splice(findIndex, 1);
            }
        }
    }, {
        key: "editTodo",
        value: function editTodo(id, text) {
            this.findTodoById(id).text = text;
        }
    }, {
        key: "completeTodo",
        value: function completeTodo(id) {
            var todo = this.findTodoById(id);
            todo.completed = !todo.completed;
        }
    }, {
        key: "completeAll",
        value: function completeAll() {
            var areAllMarked = this.store.todos.every(function (todo) {
                return todo.completed;
            });
            this.store.todos.forEach(function (todo) {
                return todo.completed = !areAllMarked;
            });
        }
    }, {
        key: "clearCompleted",
        value: function clearCompleted() {
            this.store.todos = this.store.todos.filter(function (todo) {
                return todo.completed === false;
            });
        }
    }, {
        key: "findTodoById",
        value: function findTodoById(id) {
            return this.store.todos.find(function (todo) {
                return todo.id === id;
            });
        }
    }]);

    return TODO;
}();

__decorate([src_1.Task, __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], TODO.prototype, "addTodoTask", null);
exports.default = TODO;
//# sourceMappingURL=todo.js.map