"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
/**
 * redux thunk
 */
exports.createThunkMiddleware = function (_ref) {
    var dispatch = _ref.dispatch,
        getState = _ref.getState;
    return function (next) {
        return function (action) {
            if (typeof action === "function") {
                return action(dispatch, getState);
            }
            return next(action);
        };
    };
};
/**
 * 是否是基本类型
 */
function isPrimitive(value) {
    if (value === null || value === undefined) {
        return true;
    }
    if (typeof value === "string" || typeof value === "number" || typeof value === "boolean" || value instanceof Date) {
        return true;
    }
    return false;
}
exports.isPrimitive = isPrimitive;
//# sourceMappingURL=utils.js.map